require 'net/http'
require 'net/https'

class PinController < ApplicationController
  def index
  end
  
  def show
    loadpin
  end
  
  def link
    loadpin
  end
  
  def premium
    loadpin
    if (!@pin.nil? && @pin.premium?)
      @premium = Premium.find(:first, :conditions => ["pin_id = ?",
                                                      @pin.id])
    end
    render :layout => "premium"
  end
  
  def embed
    loadpin
  end
  
  def edit
    if (loadpin)
      @pin.desc = params[:pin][:desc]
      if (params[:pin][:password] != @pin.password ||
          @pin.password.blank?)
        flash[:error] = "Wrong Password"
        render :partial => "shared/infoboxform", :locals =>
        { :innerhtml => 'inneredit', :formaction => "edit" }
      else
        @pin.update_attributes(params[:pin])
        @pin.save!
        render :partial => "redirect_to_show"
      end
    end
  end
  
  def findzip
    data = params[:zip].match(/ll=([^,]+),([^&]+)/)
    if (!data.nil?)
      @zip = Zip.new
      @zip.latitude = data[1]
      @zip.longitude = data[2]
      spn = params[:zip].match(/spn=([^,]+),([^&]+)/)
      if (!spn.nil?)
        @spanLng = spn[2]
        @spanLat = spn[1]
      end
      type = params[:zip].match(/t=(.)/)
      @mapType = type.nil? ? "m" : type[1]
    else
      @ukpc = params[:zip].scan(/([A-Z]{1,2}[0-9]{1,2}) ?([0-9][A-Z]{2})?/i)
      tofind = @ukpc.size > 0 ? @ukpc[0][0].upcase : params[:zip]
      tofind.gsub!(/^0/, '') # Remove the beginning character if it's a zero
      @zip = Zip.find(:first, :conditions => ["zip = ?", tofind])
    end
  end

  def showearth
    if (loadpin)
      send_data(render_to_string(:layout => false), :type =>"application/vnd.google-earth.kml+xml", 
                                                    :filename => "#{@pin.pinkey}.kml")
    end
  end

  def xml
    if (loadpin)
      send_data(render_to_string(:layout => false), :type => "text/xml", 
                                                    :filename => "#{@pin.pinkey}.xml")
    end
  end

  def add
    session[:adding_to] = params[:key]
    loadpin
    @master = @pin
  end

  def preview
    @master = Pin.find_by_pinkey(session[:adding_to]) unless session [:adding_to].nil?
    @pin = Pin.new(params[:pin])
    render :partial => "shared/infoboxform", :locals => { :innerhtml => '../pin/innerpreview', 
                                                          :formaction => "save" }
  end

  def save
    params[:pin][:desc] = params[:rawdesc]
    if session[:adding_to].nil?
      params[:pin][:pinkey] = Pin.generate_unique_key(params[:pin][:public])
      @pin = Pin.create(params[:pin])
      render :partial => "infoboxlink", :locals => {:action => 'link'}
    else # Adding to existing pin
      @master = Pin.find_by_pinkey(session[:adding_to])
      if (@master.nil? || params[:pin][:password] != @master.password || @master.password.blank?)
        flash[:error] = "Wrong Password"
        preview
      elsif @master.extra_pins.size > 0 and !@master.premium?
        flash[:error] = 'Limit of two pins reached on the free service'
        preview
      else
        session[:adding_to] = nil
        newpin = {}
        newpin[:lat] = params[:pin][:lat]
        newpin[:pin_id] = @master.id
        newpin[:long] = params[:pin][:long]
        newpin[:desc] = params[:pin][:desc]
        ExtraPin.create(newpin)
        render :partial => "infoboxextra"
      end
    end
  end

  def publicpinfeed
    redirect_to "http://feeds.feedburner.com/EdenDevelopment"
  end

  def checkname
    return if !loadpin

    if (params[:premium_name] !~ /^[A-Za-z0-9]+$/)
      flash[:error] = "You can only use one or more letters and/or numbers. Please try again."
      render :partial => "checkname"
      return
    end

    if (!Premium.find(:first, :conditions => ['premium_name = ?', params[:premium_name]]).nil?)
      flash[:error] = "You cannot use that name. Sorry."
      render :partial => "checkname"
      return
    end

    loadpin
    render :partial => "paypal"
  end

  def thanks
    # Get the transaction info from paypal
    url = "/cgi-bin/webscr?tx=#{params[:tx]}&cmd=_notify-synch&at=XXXXXX"

    h = Net::HTTP.new("www.paypal.com", 443)
    h.use_ssl = true
   response = h.get(url, nil)
   txn_string = response.body

    if (txn_string =~ /^FAIL/)
      render "pin/problem", :layout => "premium"
      return
    end

    @txn = { }
    txn_string.each_line do |l|
      l.chomp!
      if l !~ /=/
        next
      end
      key, val = l.split "="
      @txn[CGI.unescape(key)] = CGI.unescape(val) if (!key.nil? && !val.nil?)
    end

    @pin = Pin.find_from_key(@txn['option_selection1'])
    if (@pin.nil?)
      render "pin/problem", :layout => "premium"
      return
    end

    @pin.premium = true
    @pin.save!

    @premium = Premium.create(:pin_id => @pin.id,
                              :premium_name => @txn['option_selection2'],
                              :customer_first => @txn['first_name'],
                              :customer_last => @txn['last_name'],
                              :email => @txn['payer_email'],
                              :txn_no => @txn['txn_id'],
                              :subscr_id => @txn['subscr_id'],
                              :subtype => @txn['item_number'],
      :status_id => 1)
      
      redirect_to :action => "completed", :id => @premium.id, :key => @pin.pinkey, :plan => params[:plan]
    end
    
    def completed
      @premium = Premium.find(params[:id])
      if (@premium.nil?)
        render "pin/problem", :layout => "premium"
        return
      end
      loadpin
      
      render :layout => "premium"
    end
    
  end