module Enumerable
  def lazy_map(&block)
    LazyMap.new(self, &block)
  end
  
  class LazyMap
    include Enumerable
  
    def initialize(parent, &mapping)
      @unmapped = parent
      @mapped = []
      @mapping = mapping
    end
    
    def each(&block)
      @mapped.each do |entry|
        yield(entry)
      end
     
      while entry = @unmapped.shift
        @mapped << @mapping.call(entry)
        yield(@mapped.last)
      end
    end
  end
end