# A "handy" way to create a bunch of accessor methods on a class that
# store data in a Hash, rather than in instance variables

class Module
 def hash_accessor(hash_name, *methods)
   class_eval "def #{hash_name}; @#{hash_name} ||= {}; end"
   methods.each do |m|
     class_eval %{
       def #{m} 
         self.#{hash_name}[:#{m}] 
       end
     
       def #{m}=(v)
         self.#{hash_name}[:#{m}] = v 
       end
     }
   end
 end
end
