# This is a hash with a maximum number of items. After the maximum size
# is reached, adding a new item to the hash will delete the oldest
# existing item.
#
# Written by John Arundel and Jon Ramsey
# Copyright 2007 Rivergold Associates

class SizeLimitedHash < Hash
  def initialize(size)
    @size = size
    @queue = []
    super(0)
  end
  
  def []=(key, timestamp)
    @queue << key
    super(key, timestamp)
    self.delete(@queue.shift) if self.length > @size
  end
end


