                                                                     
                                                                     
                                                                     
                                             
class Amb
  attr_accessor :failure_continuation
  attr_accessor :fail_count
  class << self
    def all_values(&a_block)
      self.new.all_values &a_block
    end
  end


  def initialize(&block)
    self.fail_count = 0
    @error = Exception.new("Ran out of possibilities")
    @failure_continuation = lambda {|v| @error}
    if block_given?
      self.instance_eval(&block)
    end
  end

  def all_values(&a_block)
    k_prev = @failure_continuation
    results = []
    callcc do |k_retry|
      @failure_continuation = lambda {|v| k_retry.call(false)}
      results << ((a_block.arity == 1) ? a_block.call(self) : self.instance_eval(&a_block))
      k_retry.call(true)
    end && fail
    @failure_continuation = k_prev
    results
  end

  def assert(assertion = nil, &block)
    if !assertion && block_given?
      self.instance_eval(&block) || fail
    elsif !assertion
      fail
    end
  end

  def deny(assertion=nil, &block)
    if block_given?
      self.instance_eval(&block) && fail
    else
      assert(!assertion)
    end
  end

  def fail
    @fail_count = @fail_count + 1
    @failure_continuation.call(nil)
  end

  def maybe
    one_of [true, false]
  end

  def one_of(collection)
    fail if collection.nil?
    k_prev = @failure_continuation
    callcc do |k_entry|
      collection.each do |item|
        callcc do |k_next|
          @failure_continuation = lambda do |v|
            @failure_continuation = k_prev
            k_next.call(v)
          end
          k_entry.call(item)
        end
      end
      result = k_prev.call(nil)
      if result == @error
        raise @error.message
      end
    end
  end

  class Tuple
    def initialize(amb, initial_or_size)
      @amb  = amb
      case initial_or_size
      when Array
        @arr  = initial_or_size
      else
        @arr  = Array.new(initial_or_size.to_i)
      end
    end

    def [](*args)
      @arr[*args]
    end

    def []=(index, newval)
      k_prev = @amb.failure_continuation
      if index >= @arr.size
        oldarr = @arr
        @amb.failure_continuation = lambda do |v|
          @arr = oldarr
          k_prev.call(v)
        end
        @arr = @arr.dup
      else
        oldval = @arr[index]
        @amb.failure_continuation = lambda do |v|
          @arr[index] = oldval
          k_prev.call(v)
        end
      end
      @arr[index] = newval
    end

    def <<(val)
      oldval = @arr
      k_prev = @amb.failure_continuation
      @amb.failure_continuation = lambda do |v|
        @arr = oldval
        k_prev.call(v)
      end
      @arr = @arr.dup << val
      return self
    end

    def to_s
      @arr.to_s
    end

    def inspect
      @arr.inspect
    end

    def method_missing(sym, *args, &block)
      @arr.send(sym, *args, &block)
    end
  end

  class Atom
    def initialize(amb, initial_value = nil)
      @amb = amb
      @value = initial_value
    end

    def <<(newval)
      k_prev = @amb.failure_continuation
      oldval = @value
      @amb.failure_continuation = lambda do |v|
        @value = oldval
        k_prev.call(v)
      end
      @value = newval
    end

    def to_s
      @value.to_s
    end

    def inspect
      @value.to_s
    end

    def method_missing(meth, *args, &block)
      @value.send(meth, *args, &block)
    end
  end

  def atom(value=nil)
    Atom.new(self, value)
  end

  def tuple(size)
    case size
    when Tuple
      size
    else
      Tuple.new(self, size)
    end
  end
end


amb = Amb.new

# fletcher = amb.one_of(1..5)
# amb.deny(fletcher == 5)
# amb.deny(fletcher == 1)

# smith = amb.one_of(1..5)
# amb.deny((smith - fletcher).abs == 1)

# cooper = amb.one_of(1..5)
# amb.deny(cooper == 1)
# amb.deny((fletcher - cooper).abs == 1)

# miller = amb.one_of(1..5)
# amb.assert(miller > cooper)

# baker = amb.one_of(1..5)
# amb.deny(baker == 5)

# amb.assert([baker, cooper, fletcher, miller, smith].uniq.size == 5)

# puts "Baker lives on #{baker}"
# puts "Cooper lives on #{cooper}"
# puts "Fletcher lives on #{fletcher}"
# puts "Miller lives on #{miller}"
# puts "Smith lives on #{smith}"


# s = Sudoku.new(<<EOS)
# ...67....
# ..1..83..
# ..5....91
# .1...7...
# .8.9.4.2.
# ...3...4.
# 63....8..
# ..74..9..
# ....35...
# EOS

# puts "Solving Sudoku:"
# puts s.unsolved_state
# puts "Solution is:"
# puts s.solution
